/**
 * string-remove-duplicate-heads-tails
 * Detect and (recursively) remove head and tail wrappings around the input string
 * Version: 5.0.9
 * Author: Roy Revelt, Codsen Ltd
 * License: MIT
 * Homepage: https://codsen.com/os/string-remove-duplicate-heads-tails/
 */

import t from"lodash.isplainobject";import{arrayiffy as e}from"arrayiffy-if-string";import{matchRightIncl as r,matchLeftIncl as i}from"string-match-left-right";import{Ranges as s}from"ranges-push";import{rApply as n}from"ranges-apply";import{trimSpaces as a}from"string-trim-spaces-only";const o="5.0.9",h={heads:["{{"],tails:["}}"]};function l(o,h){const l=Object.prototype.hasOwnProperty;if(void 0===o)throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_01] The input is missing!");if("string"!=typeof o)return o;if(h&&!t(h))throw new Error(`string-remove-duplicate-heads-tails: [THROW_ID_03] The given options are not a plain object but ${typeof h}!`);const c={...h};if(c&&l.call(c,"heads")){if(!e(c.heads).every((t=>"string"==typeof t||Array.isArray(t))))throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_04] The opts.heads contains elements which are not string-type!");"string"==typeof c.heads&&(c.heads=e(c.heads))}if(c&&l.call(c,"tails")){if(!e(c.tails).every((t=>"string"==typeof t||Array.isArray(t))))throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_05] The opts.tails contains elements which are not string-type!");"string"==typeof c.tails&&(c.tails=e(c.tails))}const p=a(o).res;if(0===p.length)return o;o=p;const f={heads:["{{"],tails:["}}"],...c};f.heads=f.heads.map((t=>t.trim())),f.tails=f.tails.map((t=>t.trim()));let m=!1,g=!1;const u=new s({limitToBeAddedWhitespace:!0}),d=new s({limitToBeAddedWhitespace:!0});let y=!0,w=!0,b="";function B(t,e){let i;if(!r(t,0,e.heads,{trimBeforeMatching:!0,cb:(t,e,r)=>(i=r,!0)}))return t;return r(t,i,e.tails,{trimBeforeMatching:!0,cb:(t,e,r)=>(i=r,!0)})?t.slice(i):t}for(;o!==B(o,f);)o=a(B(o,f)).res;function T(t,e){let r;if(!i(t,t.length-1,e.tails,{trimBeforeMatching:!0,cb:(t,e,i)=>(r=i,!0)})||!r)return t;return i(t,r,e.heads,{trimBeforeMatching:!0,cb:(t,e,i)=>(r=i,!0)})?t.slice(0,r+1):t}for(;o!==T(o,f);)o=a(T(o,f)).res;if(!(f.heads.length&&r(o,0,f.heads,{trimBeforeMatching:!0})&&f.tails.length&&i(o,o.length-1,f.tails,{trimBeforeMatching:!0})))return a(o).res;for(let t=0,e=o.length;t<e;t++)if(""===o[t].trim());else{let e;if(r(o,t,f.heads,{trimBeforeMatching:!0,cb:(t,r,i)=>(e=i,!0)})&&e){let i;w=!0,y&&(y=!0);r(o,e,f.tails,{trimBeforeMatching:!0,cb:(t,e,r)=>(i=r,!0)})&&u.push(t,i),d.current()&&m&&"tails"!==b&&u.push(d.current()),m||d.current()&&(u.push(d.current()),d.wipe()),d.push(t,e),b="heads",t=e-1;continue}if(r(o,t,f.tails,{trimBeforeMatching:!0,cb:(t,r,i)=>(e=Number.isInteger(i)?i:o.length,!0)})&&e){w=!0,y?("heads"===b&&d.wipe(),y=!1):d.push(t,e),b="tails",t=e-1;continue}y&&(y=!0),w&&!m?(m=!0,w=!1):w&&!g?(g=!0,y=!0,w=!1,"heads"===b&&d.wipe()):w&&g&&d.wipe()}return d.current()&&u.push(d.current()),u.current()?n(o,u.current()).trim():o.trim()}export{h as defaults,l as remDup,o as version};
